config/routes.rb
# frozen_string_literal: true

require "sidekiq/web"
require "sidekiq/cron/web"

Sidekiq::Web.use(Auth)

Rails.application.routes.draw do
  Healthcheck.routes(self)

  concern :paginatable do
    get "(page/:page)", action: :index, on: :collection, as: ""
  end

  mount Sidekiq::Web, at: "/sidekiq"
  mount AuthHelper.with_auth(Yabeda::Prometheus::Exporter), at: "/metrics", via: :get if AppConfig.metrics?
  mount API => "/"

  root AppConfig.anonymous_access ? "projects#index" : "sessions#new"

  get "sign_in", to: "sessions#new"
  post "sign_in", to: "sessions#create"
  delete "logout", to: "sessions#destroy"

  put "/jobs/:id/execute", to: "job#execute", as: "job_execute"

  get "new_project", to: "projects#new"
  resources :projects, only: %i[index create update destroy], concerns: :paginatable
end

app/models/project.rb
# frozen_string_literal: true

# Gitlab project
#
# @!attribute id
#   @return [Integer]
# @!attribute name
#   @return [String]
# @!attribute forked_from_id
#   @return [Integer]
# @!attribute forked_from_name
#   @return [String]
# @!attribute webhook_id
#   @return [Integer]
# @!attribute web_url
#   @return [String]
# @!attribute gitlab_access_token
#   @return [String]
# @!attribute merge_requests
#   @return [Array<MergeRequest>]
# @!attribute vulnerability_issues
#   @return [Array<VulnerabilityIssue>]
# @!attribute update_jobs
#   @return [Array<Update::Job>]
# @!attribute configuration
#   @return [Configuration]
class Project
  include Mongoid::Document

  paginates_per 10

  unalias_attribute :id

  field :name, type: String
  field :id, type: Integer
  field :forked_from_id, type: Integer
  field :forked_from_name, type: String
  field :webhook_id, type: Integer
  field :web_url, type: String
  field :gitlab_access_token, type: EncryptedString

  has_many :merge_requests, dependent: :destroy
  has_many :vulnerability_issues, dependent: :destroy
  has_many :update_jobs, class_name: "Update::Job", dependent: :destroy

  embeds_one :configuration

  index({ id: 1 }, { unique: true })
  index({ name: 1 }, { unique: true })
  index(name: "text")

  # All open merge requests
  #
  # @param [String] package_ecosystem
  # @param [String] directory
  # @return [Array<MergeRequest>]
  def open_merge_requests(package_ecosystem:, directory:)
    merge_requests.where(
      package_ecosystem: package_ecosystem,
      directory: directory,
      state: "opened"
    )
  end

  # Project open merge requests
  #
  # @param [String] dependency_name
  # @param [String] directory
  # @return [Array<MergeRequest>]
  def open_dependency_merge_requests(dependency_name, directory)
    merge_requests
      .where(main_dependency: dependency_name, directory: directory, state: "opened")
      .compact
  end

  # :reek:LongParameterList

  # Open superseded merge requests
  #
  # @param [String] package_ecosystem
  # @param [String] directory
  # @param [String] update_from
  # @param [Integer] mr_iid
  # @return [Array<MergeRequest>]
  def superseded_mrs(package_ecosystem:, directory:, update_from:, mr_iid:)
    merge_requests
      .where(
        update_from: update_from,
        package_ecosystem: package_ecosystem,
        directory: directory,
        state: "opened"
      )
      .not(iid: mr_iid)
      .compact
  end

  # Open vulnerability issues
  #
  # @param [String] package_ecosystem
  # @param [String] directory
  # @param [String] package
  # @return [Array<VulnerabilityIssue>]
  def open_vulnerability_issues(package_ecosystem:, directory:, package:)
    vulnerability_issues
      .where(
        directory: directory,
        package: package,
        package_ecosystem: package_ecosystem,
        status: "opened"
      )
  end

  # Return projects hash representation
  #
  # @return [Hash]
  def to_hash
    {
      id: id,
      name: name,
      forked_from_id: forked_from_id,
      forked_from_name: forked_from_name,
      webhook_id: webhook_id,
      web_url: web_url,
      configuration: configuration&.updates
    }
  end

  class Entity < Grape::Entity
    expose :id, documentation: { type: Integer, desc: "Project ID" }
    expose :name, documentation: { type: String, desc: "Project full path" }
    expose :forked_from_id, documentation: { type: Integer, desc: "Forked from project ID" }
    expose :forked_from_name, documentation: { type: String, desc: "Forked from project full path" }
    expose :webhook_id, documentation: { type: Integer, desc: "Project webhook ID" }
    expose :web_url, documentation: { type: String, desc: "Project web URL" }
    expose :configuration, using: Configuration::Entity

    # Example response hash
    #
    # @return [Hash]
    def self.example_response
      {
        id: 1,
        name: "foo/bar",
        forked_from_id: 2,
        forked_from_name: nil,
        webhook_id: 3,
        web_url: "https://gitlab.com/foo/bar",
        configuration: Configuration::Entity.example_response
      }
    end
  end
end

app/controllers/projects_controller.rb
# frozen_string_literal: true

class ProjectsController < ApplicationController
  before_action :authenticate_user!

  # Render add new project page
  #
  # @return [void]
  def new; end

  # Render index projects page
  #
  # @return [void]
  def index
    return @projects = Project.order(name: :asc).page(params[:page]) if params[:project_name].blank?

    @projects = Project.where("$text" => { "$search" => params[:project_name] }).order(name: :asc).page(params[:page])
  end

  # Add new project
  #
  # @return [void]
  def create
    project_name = params.require(:project_name)
    access_token = params[:access_token].presence

    existing_project = find_project(name: project_name)
    return redirect_to(projects_path, notice: "Project already added!") if existing_project

    project = Dependabot::Projects::Creator.call(params.require(:project_name), access_token: access_token)
    return redirect_to(projects_path, notice: "Empty project added") unless project.configuration

    Cron::JobSync.call(project)
    redirect_to projects_path, notice: "Project added"
  rescue Gitlab::Error::Error => e
    redirect_to new_project_path, alert: e.message
  end

  # Sync existing project
  #
  # @return [void]
  def update
    project = find_project(id: params.require(:id))

    updated_project = Dependabot::Projects::Creator.call(project.name, access_token: project.gitlab_access_token)
    Cron::JobSync.call(updated_project)

    redirect_to projects_path, notice: "Project updated"
  end

  # Delete existing project
  #
  # @return [void]
  def destroy
    project = find_project(id: params.require(:id))
    Dependabot::Projects::Remover.call(project)

    redirect_to projects_path, notice: "Project removed"
  end
end

app/views/projects/_header.html.erb
<div class="header-button-container">
  <%= button_to "Home", root_path, method: :get %>
  <%= button_to "v#{version}", "https://dependabot-gitlab.gitlab.io/dependabot", method: :get, style: "margin-left: 5px" %>
  <%= button_to "Logout", logout_path, method: :delete, title: "Logout", style: "margin-left: 5px" unless AppConfig.anonymous_access %>
</div>

app/views/projects/_project_table.html.erb
<header>
  <h2><%= link_to_if project.web_url, project.name, project.web_url %></h2>
</header>
<div class="button-container">
  <%= button_to "Sync", project_path(project.id), method: :put, title: "Sync project configuration", style: "margin-right: 5px" %>
  <%= button_to "Delete", project_path(project.id), method: :delete, title: "Remove project" %>
</div>

<table class="blueTable">
  <thead>
    <tr>
      <th>Package ecosystem</th>
      <th>Directory</th>
      <th>Cron</th>
      <th>Last executed</th>
      <th>Last execution errors</th>
      <th>Open merge requests</th>
      <th>Actions</th>
    </tr>
  </thead>

  <tbody>
    <% if project.update_jobs.empty? %>
      <tr>
        <td>No jobs configured</td>
      </tr>
    <% else %>
      <% project.update_jobs.each do |job| %>
        <% config_entry = project.configuration.entry(package_ecosystem: job.package_ecosystem, directory: job.directory) %>
        <% next log(:error, "Tried to render job entry but missing configuration entry for project '#{project.name}=>#{job.package_ecosystem}=>#{job.directory}'") unless config_entry %>
        <tr>
          <td><%= job.package_ecosystem %></td>
          <td><%= job.directory %></td>
          <td><%= job.cron %></td>
          <td><%= job.last_executed&.to_formatted_s(:long) %>
          <td><%= job.last_failures %></td>
          <td>
            <%=
              mrs = open_merge_requests(project, job.package_ecosystem, job.directory).length
              link_to_if(mrs > 0, mrs, open_mrs_url(project, config_entry))
            %>
          </td>
          <td>
            <%= button_to "Execute", job_execute_path(job.id), method: :put, title: "Execute job now" %>
          </td>
        </tr>
      <% end %>
    <% end %>
  </tbody>
</table>

app/views/projects/index.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Dependabot Gitlab</title>
    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
  </head>

  <body>
    <%= render partial: 'header' %>
    <h1>Projects</h1>
    <%= button_to "Add new project", new_project_path, title: "Add new project", method: :get, id: :add_new_project %>
    <hr class="solid">
    <div class="search-container">
    <%= form_with url: projects_path, method: :get, id: "search-form" do |form| %>
      <div>
        <%= form.search_field :project_name, placeholder: "Project name" %>
        <%= form.submit "Search", class: "submit-search" %>
      </div>
    <% end %>
    <%= button_to "✖", projects_path, method: :get, class: "clear-search", style: "margin-left: 1px" %>
    </div>

    <% @projects.each do |project| %>
      <%= render partial: 'project_table', locals: { project: project } %>
    <% end %>
    <%= paginate @projects %>
  </body>
</html>

app/views/projects/new.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Dependabot Gitlab</title>
    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
  </head>

  <body>
    <h1>New Project</h1>
    <%= render partial: 'header' %>
    <% flash.each do |type, msg| %>
      <p>
        <strong><%= type %></strong>: <%= msg %>
      </p>
    <% end %>

    <%= form_with url: projects_path, method: :post do |form| %>
      <%= form.text_field :project_name, placeholder: "Full project path" %>
      <%= form.text_field :access_token, placeholder: "Access token: (optional)" %>
      <%= form.submit "Add", id: :add_project %>
    <% end %>
  </body>
</html>